<script setup lang="ts">
import { computed, onMounted, type PropType, ref, watch } from "vue";
import type { ExtendedColors, SizeModifierType } from "@/types/PropTypes";

const model = defineModel({ required: true });
const props = defineProps({
  parameter: {
    type: Object,
    required: true,
  },
  required: Boolean,
  helpId: {
    type: String,
  },
  sizeModifier: {
    type: String as PropType<SizeModifierType>,
  },
  border: String as PropType<ExtendedColors>,
  resourceParameter: Boolean,
  allowSwitch: Boolean,
  id: String,
  customValidity: { type: String, required: false },
});

const emit = defineEmits<{
  (e: "disable-raw"): void;
}>();

watch(
  () => props.customValidity,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      stringInput.value?.setCustomValidity(newVal ?? "");
    }
  },
);

const fileOrResource = computed<boolean>(() => {
  return (
    (props.resourceParameter || props.parameter["format"]) && props.allowSwitch
  );
});

const dynamicCssClass = computed<string[]>(() => {
  const cssClasses = [];
  if (props.sizeModifier) {
    cssClasses.push(`form-control-${props.sizeModifier}`);
  }
  if (!helpTextPresent.value && !fileOrResource.value) {
    cssClasses.push("rounded-end");
  }
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`);
  }
  return cssClasses;
});

const stringInput = ref<HTMLInputElement | undefined>(undefined);
const pattern = computed<string>(() => props.parameter["pattern"]);
const helpTextPresent = computed<boolean>(() => props.parameter["help_text"]);

onMounted(() => {
  stringInput.value?.setCustomValidity(props.customValidity ?? "");
});
</script>

<template>
  <input
    :id="id"
    ref="stringInput"
    v-model="model"
    class="form-control"
    :class="dynamicCssClass"
    type="text"
    :required="props.required"
    :aria-describedby="props.helpId"
    :pattern="pattern"
  />
  <button
    v-if="fileOrResource"
    type="button"
    class="btn btn-secondary"
    @click="emit('disable-raw')"
  >
    Raw
  </button>
</template>

<style scoped></style>
